/* 
    Date: september 2003

This DOS\Windows Base64 encode/decode routine program is provided as
an attachment to "CODiCE iNVERSO", an e-zine text about digital
cryptography, published on Ondaquadra #10 (www.ondaquadra.org) by
Zer0 (Massimo De Lirio, Italy). The code is "as is", and has not been
proved to be correct, bug-free or even not potentially dangerous. You
can distribute it or modify without any limitation (I'll be glad to
you if you don't remove this intro, though...), nor warranty.
It is not intended to be a definitive program, so please don't report
me any bug or error you find in the code: I will not correct it, this
is only a sample program intended to demonstrate the basics of a base
64 routine programming in C.
If you have any question about, I recommend you to give a look at
CODiCE iNVERSO (a quite long text, it starts on Ondaquadra #03, it's
in Italian, though!), you can also find in Ondaquadra #10 my e-mail
address and my PGP public keys.

KEY 1: RSA 2046/ IDEA 128
    Key ID: 0xA711DDC9
    Key fingerprint: 1693 8400 7E5E F1C8  F34E 9970 3892 BD70
    Created on: 02/06/01 (never expires)

KEY 2: DH 4095/ DSA 1024/ IDEA 128
    Key ID: 0x01965550
    Key fingerprint: 989B 2124 8577 E5B9 3BFE  9B2D B22E 46BB 0196 5550
    Created on: 19/08/01 (never expires)

*/


#include <stdio.h>
#include <malloc.h>
#include <string.h>

long int errval;

char convertiontable64[64] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

unsigned char deconvertiontable64[256] = {
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0x3E,	0xFF,	0xFF,	0xFF,	0x3F,
	0x34,	0x35,	0x36,	0x37,	0x38,	0x39,	0x3A,	0x3B,
	0x3C,	0x3D,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0x00,	0x01,	0x02,	0x03,	0x04,	0x05,	0x06,
	0x07,	0x08,	0x09,	0x0A,	0x0B,	0x0C,	0x0D,	0x0E,
	0x0F,	0x10,	0x11,	0x12,	0x13,	0x14,	0x15,	0x16,
	0x17,	0x18,	0x19,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0x1A,	0x1B,	0x1C,	0x1D,	0x1E,	0x1F,	0x20,
	0x21,	0x22,	0x23,	0x24,	0x25,	0x26,	0x27,	0x28,
	0x29,	0x2A,	0x2B,	0x2C,	0x2D,	0x2E,	0x2F,	0x30,
	0x31,	0x32,	0x33,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,	0xFF,
};


long int base64_encode (char *Input, unsigned long int lenght, char **Output) {
	/* DICHIARAZIONI */
	long int i, l;
	register unsigned long int buffer;
	register long int pos;
	char Char;
	/* INIZIALIZZAZIONI */
	if (!lenght) return -5;
	buffer = lenght / 3;
	pos = (long int) lenght % 3;
	l = (long int) buffer;
	if (pos) buffer++;
	buffer <<= 2;
	buffer++;
	*Output = (char *) malloc(buffer);
	if (!(*Output)) return -1;
	i = 0;
	if (!l) goto step;
	l += (l << 1);
	pos = 0;
	/* CONVERSIONE */
	while (i < l) {
		buffer = *((unsigned long int *) &(Input[i]));
		buffer = (buffer & 0xFF00) | ((buffer & 0xFF0000) >> 16) | ((buffer & 0xFF) << 16);
		Char = (char) (buffer >> 18);
		(*Output)[pos] = convertiontable64[Char];
		Char = (char) ((buffer >> 12) & 0x3F);
		(*Output)[pos + 1] = convertiontable64[Char];
		Char = (char) ((buffer >> 6) & 0x3F);
		(*Output)[pos + 2] = convertiontable64[Char];
		Char = (char) (buffer & 0x3F);
		(*Output)[pos + 3] = convertiontable64[Char];
		pos += 4;
		i += 3;
	};
step:
	/* FINE STRINGA */
	l = (long int) lenght % 3;
	switch (l) {
		case 0: {
			(*Output)[pos] = 0;
			break;
		};
		case 1: {
			buffer = *((unsigned long int *) &(Input[i]));
			Char = (char) (buffer & 0xFC) >> 2;
			(*Output)[pos] = convertiontable64[Char];
			buffer <<= 4;
			Char = (char) buffer & 0x3F;
			(*Output)[pos + 1] = convertiontable64[Char];
			(*Output)[pos + 2] = '=';
			(*Output)[pos + 3] = '=';
			(*Output)[pos + 4] = 0;
			break;
		};
		case 2: {
			buffer = *((unsigned long int *) &(Input[i]));
			buffer = (buffer & 0xFF00) | ((buffer & 0xFF) << 16);
			Char = (char) (buffer >> 18);
			(*Output)[pos] = convertiontable64[Char];
			Char = (char) ((buffer >> 12) & 0x3F);
			(*Output)[pos + 1] = convertiontable64[Char];
			Char = (char) ((buffer >> 6) & 0x3F);
			(*Output)[pos + 2] = convertiontable64[Char];
			(*Output)[pos + 3] = '=';
			(*Output)[pos + 4] = 0;
			break;
		};
	};
	return 0;
}


long int base64_decode (char *Input, char **Output, unsigned long int *lenght) {
	/* DICHIARAZIONI */
	register unsigned long int buffer;
	register unsigned char Char;
	long int i;
	unsigned long int valid;
	long int pos;
	/* INIZIALIZZAZIONI */
	valid = 0;
	pos = strlen(Input);
	pos += pos << 1;
	buffer = (pos >> 2) + 1;
	pos = 0;
	if (buffer == 1) return -4;
	*Output = (char *) malloc(buffer);
	if (!(*Output)) return -1;
	buffer = 0;
	/* DECONVERSIONE */
	for (i = 0; Input[i]; i++) {
		Char = deconvertiontable64[Input[i]];
		if (Char > 63) continue;
		valid++;
		buffer <<= 6;
		buffer |= (unsigned long int) Char;
		if (!(valid & 3)) {
			Char = (unsigned char) (buffer >> 16);
			(*Output)[pos] = (char) Char;
			Char = (unsigned char) (buffer >> 8);
			(*Output)[pos + 1] = (char) Char;
			Char = (unsigned char) buffer;
			(*Output)[pos + 2] = (char) Char;
			pos += 3;
			buffer = 0;
		};
	};
	if (!valid) return -3;
	/* FINE STRINGA */
	Char = (unsigned char) (valid & 3);
	switch (Char) {
		case 0: {
			(*Output)[pos] = 0;
			*lenght = (unsigned long int) pos;
			break;
		};
		case 1: {
			return -4;
		};
		case 2: {
			Char = (unsigned char) (buffer >> 4);
			(*Output)[pos] = (char) Char;
			(*Output)[pos + 1] = 0;
			*lenght = (unsigned long int) pos + 1;
			break;
		};
		case 3: {
			Char = (unsigned char) (buffer >> 10);
			(*Output)[pos] = (char) Char;
			Char = (unsigned char) (buffer >> 2);
			(*Output)[pos + 1] = (char) Char;
			(*Output)[pos + 2] = 0;
			*lenght = (unsigned long int) pos + 2;
			break;
		};
	};
	/* RIALLOCAZIONE SPAZIO SPRECATO */
	if (valid != strlen(Input)) {
		*Output = (char *) realloc(*Output, *lenght + 1);
	};
	return 0;
}
